/*
 * Copyright (C) Microsoft Corporation, 1982
 */
#
/*
 *  C compiler
 */

#include "c1.h"
#include <setjmp.h>

int aopt_debug;
int bopt_debug;
static int lbl, lbl2, lbl3;
#ifndef STKBOUND
#define STKBOUND 100
#endif
int stkbound = STKBOUND;

jmp_buf fpenv ;

max(a, b)
{
	if (a>b)
		return(a);
	return(b);
}

degree(at)
struct tnode *at;
{
	register struct tnode *t, *t1;

	if ((t=at)==0 || t->op==0)
		return(0);
	if (t->op == CON)
		return(-3);
	if (t->op == AMPER) {
		if (t->tr1->op == NAME && t->tr1->class == EXTERN || t->tr1->class == STATIC)
			return(-2);
		return(1);
	}
	if (t->op==ITOL) {
		if ((t1 = isconstant(t)) && (t1->value>=0 || t1->type==UNSIGN))
			return(-2);
		if ((t1=t->tr1)->type==UNSIGN && opdope[t1->op]&LEAF)
			return(-1);
	}
	if ((opdope[t->op] & LEAF) != 0) {
		if (t->type==CHAR || t->type==FLOAT)
			return(1);
		return(0);
	}
	return(t->degree);
}

pname(ap, flag)
struct tnode *ap;
{
	register i;
	register struct tnode *p;
	register funcname = 0 ;
	struct { int intx[2]; };

	p = ap;
loop:
#if DEBUG
	dbprt("trc","pname loop - flag %d,type %x,op%d,class %d\n",
	flag,p->type,p->op,p->class) ;
#endif
	if (p->op==NAME && ((p->type&XTYPE) == FUNC))
		funcname = 1;
	switch(p->op) {

	case LCON:
		pvalue(flag>10? p->lvalue.intx[1]:p->lvalue.intx[0]);
		return;

	case CON:
		pvalue(p->value);
		return;

	case SFCON:
	case FCON:
		printf("L%d", (p->value>0? p->value: -p->value));
		return;

	case NAME:
		i = p->offset;
#ifdef DEBUG
		dbprt("trc","name offset %d,class %d\n",i,p->class) ;
#endif
		if (flag>10)
#ifdef INTERMED
		    if(!funcname)
#endif
			i =+ 2;
		if (i) {
			if (p->class!=OFFS) printf("%d.+",i);
			else pvalue(i);
			if (p->class==REG) regerr();
		}
		switch(p->class) {

		case SOFFS:
		case XOFFS:
			pbase(p);

		case OFFS:
			printf("(%s)",reg_names[p->regno]);
			return;

		case EXTERN:
		case STATIC:
			if(funcname)
#ifdef INTERMED
				{
				if(flag>10)
					printf("{") ;
				else
					printf("[") ;
				}
#else
				printf("[") ;
#endif
			pbase(p);
			if(funcname)
#ifdef INTERMED
				{
				funcname=0;
				if(flag>10)
					printf("}") ;
				else
					printf("]") ;
				}
#else
				printf("]") ;
#endif
			return;

		case REG:
			printf("%s",reg_names[p->nloc]);
			return;

		}
		error("Compiler error: pname");
		return;

	case AMPER:
		putchar('#');
		p = p->tr1;
#ifdef DEBUG
		dbprt("trc","amper p->tr1->op %d,p->tr1->class %d,type %x\n",
			p->op,p->class,p->type) ;
#endif
		if (p->op==NAME && p->class==REG)
			regerr();
		goto loop;

	}
	error("pname called illegally");
}

regerr()
{
#if DEBUG
	dbprt("trc","regerr called\n") ;
#endif
	error("Illegal use of register");
}

pbase(ap)
struct tnode *ap;
{	register struct tnode *p;
	register char *q,*r;
	int i; char nbuf[NCPS+2];

	p = ap;
	if (p->class==SOFFS || p->class==STATIC)
		printf("L%d", p->nloc);
	else
	 { for (i=0, r=nbuf, q = &(p->nloc); i<8 && (*r++ = *q++); i++);
	   nbuf[i] = '\0';
	   printf("%.8s", nbuf);
	 };
}


pvalue(i)
 register int i;
 {	printf("%c%d.",pchar(i),i);
 }

pchar(i)
 register int i;
 {	return((i>=-128 && i<=127)?'*':'#');
 }

xdcalc(ap, nrleft)
struct tnode *ap;
{
	register struct tnode *p;
	register d;

	p = ap;
	d = dcalc(p, nrleft);
/*	error("xdcalc: op=%s, nrleft=%d, d=%d",opntab[p->op],nrleft,d);
/*	if (d<20 && p->type==CHAR) {
		if (nrleft>=1)
			d = 20;
		else
			d = 24;
	}
*/	return(d);
}

dcalc(ap, nrleft)
struct tnode *ap;
{
	register struct tnode *p, *p1;

	if ((p=ap)==0)
		return(0);
#if DEBUG
	dbprt("tree","dcalc: op=%s degree=%d regs left=%d,type %x\n",
	opntab[p->op],p->degree,nrleft,p->type); 
#endif
	switch (p->op) {

	case NAME:
		if (p->class==REG) return(9);
		else return(12);

	case AMPER:
#if INTERMED
		if (TESTL(p) && 
		    (p->tr1->class == EXTERN || p->tr1->class == STATIC))
			 return(16) ;
#endif
		if (p->tr1->class == EXTERN || p->tr1->class == STATIC)
			return(8);
		break;
	case LCON:
		return(8);

	case CON:
	case SFCON:
		if (p->value==0)
			return(4);
		if (p->value==1)
			return(5);
		if (p->value>=-128 && p->value<=127)
			return(7);
		return(8);

	case FCON:
		return (12);

	case STAR:
		p1 = p->tr1;
		if (indexp(p1) && p1->offset==0 && (!TESTL(p))) return(12);
		return(24);
	}
	if (TESTL(p))
		nrleft--;
	return(p->degree < nrleft? 20: 24);
}

/* the table source entries for type flags:
	no flag = 0		INT = 0
	w = 1			CHAR = 1
	i = 2			FLOAT = 2
	b = 3			DOUBLE = 3
	f = 4			STRUCT = 4
	d = 5			RSTRUCT = 5
	u = 9			LONG = 6
	s = 6			UNSIGN = 7
	l = 8			PTR = 010
	p += 16			FUNC = 020
				ARRAY = 030
*/
notcompat(ap, ast, op)
struct tnode *ap;
{
	register at, st;
	register struct tnode *p;

	p = ap;
	at = p->type;
	st = ast;
#ifdef DEBUG
	dbprt("trc","trc - notcompat - type %x,tabtyp %x,op %d\n",at,st,op) ;
#endif
#if INTERMED
	if (st==0)		/* word, byte */
		return(at!=CHAR && at!=INT && at!=UNSIGN && 
		(at<PTR || (at&XTYPE) == LPTR));
	if (st==1)		/* word */
		return(at!=INT && at!=UNSIGN && 
		(at<PTR || (at&XTYPE) == LPTR));
	if (st==9 && (at&XTYPE) && ((at&XTYPE) != LPTR))
		return(0);
	if (st==24 && (at&XTYPE) == LPTR)
		return(0) ;	/* long pointers 16 + 8 */
	st =- 2;
	if(at&XTYPE)
		{			/* sub typed */
		if (((at&XTYPE) == LPTR) || ((at&XTYPE) == FUNC))
			at = LONG  | 020;	/* +16 for long ptr -
						   p in the templates */
		else			/* ptr to current type */
			at = at&TYPE | PTR;
		at&=(XTYPE+TYPE);	/* clear remaining subtypes */
		}
	if (st==FLOAT && at==DOUBLE)
		at = FLOAT;
	if (p->op==NAME && p->class==REG && op==ASSIGN && st==CHAR)
		return(0);
#ifdef DEBUG
	dbprt("trc","trc - notcompat evolved type %x\n",at) ;
#endif
	return(st != at);
#else
	if (st==0)		/* word, byte */
		return(at!=CHAR && at!=INT && at!=UNSIGN && at<PTR);
	if (st==1)		/* word */
		return(at!=INT && at!=UNSIGN && at<PTR);
	if (st==9 && (at&XTYPE))
		return(0);
	st =- 2;
	if ((at&(~(TYPE+XTYPE))) != 0)
		{
#ifdef DEBUG
		dbprt("trc","trc-notcompat I didn't think this could happen\n");
#endif
		at = 020;
		}
	if ((at&(~TYPE)) != 0)
		at = at&TYPE | 020;
	if (st==FLOAT && at==DOUBLE)
		at = FLOAT;
	if (p->op==NAME && p->class==REG && op==ASSIGN && st==CHAR)
		return(0);
#ifdef DEBUG
	dbprt("trc","trc - notcompat evolved type %x\n",at) ;
#endif
	return(st != at);
#endif
}

prins(op, c, itable)
struct instab *itable;
{
	register struct instab *insp;
	register char *ip;

	for (insp=itable; insp->op != 0; insp++) {
		if (insp->op == op) {
			ip = c? insp->str2: insp->str1;
			if (ip==0)
				break;
			printf("%s", ip);
#ifdef DEBUG
	dbprt("trc","prins c=%d,op=%d,string %s\n",c,op,ip) ;
#endif
			return;
		}
	}
	error("No match' for op %d", op);
}

collcon(ap, reg)
struct tnode *ap;
{
	register op;
	register struct tnode *p;
	int i;

	p = ap;
	if (p->op==PLUS) {
		op = p->tr2->op;
		if (op==CON)
			return(1);
		if (op == AMPER) {
			p = p->tr2->tr1;
			if (p->op == NAME && ((i = p->class) == EXTERN || i == STATIC))
				return(1);
			return(0);
		}
	}
	return(0);
}

isfloat(at)
struct tnode *at;
{
	register struct tnode *t;

	if((t = at)==0) return (0);
	if ((opdope[t->op]&RELAT)!=0)
		t = t->tr1;
#ifdef DEBUG
	dbprt("trc","trc - isfloat op %d type %x,t op %d t type %x\n",
	at->op,at->type,t->op,t->type) ;
#endif
	if (t->type==FLOAT) {
		nfloat = 1;
		return(1);
	}
	if (t->type==DOUBLE) {
		nfloat = 1;
		return(2);
	}
	return(0);
}

islng(at)
struct tnode *at;
{
	register struct tnode *t;

	if((t = at)==0) return (0);
	if ((opdope[t->op]&RELAT)||t->op==LOGAND||t->op==LOGOR||t->op==EXCLA)
		t = t->tr1;
#ifdef DEBUG
	dbprt("trc","trc - islng op %d type %x,t op %d t type %x\n",
	at->op,at->type,t->op,t->type) ;
#endif
	if (TESTL(t)) {
		return(1);
	}
	return(0);
}

/*
oddreg(t, areg)
struct tnode *t;
{
	register reg;

	reg = areg;
	if (!isfloat(t))
		switch(t->op) {
		case LLSHIFT:
		case ASLSHL:
			return((reg+1)&~01);

		case TIMES:
		case ASTIMES:
		case DIVIDE:
		case MOD:
		case ASDIV:
		case ASMOD:
		case PTOI:
			return(AX);
		}
	return(reg);
}
*/

arlength(t)
{
	if (t>=PTR)
		{
#ifdef INTERMED
		if((t&XTYPE) == LPTR)
			return(4) ;	/* long pointer */
		else
#endif
			return(2);
		}
	switch(t) {

	case INT:
	case CHAR:
	case UNSIGN:
		return(2);

	case LONG:
		return(4);

	case FLOAT:
	case DOUBLE:
		return(8);
	}
	return(1024);
}

/*
 * Strings for switch code.
 */

char dirsw[] {"\
cmp	ax,%c%d.\n\
bhi	L%d\n\
shl	ax,#1\n\
xchg	bx,ax\n\
seg	cs\n\
.segrel\n\
jmp	@L%d(bx)\n\
L%d:\
" };

char	hashsw[] {"\
sub	dx,dx\n\
mov	bx,#%d.\n\
div	bx\n\
shl	dx,*1\n\
mov	bx,dx\n\
seg	cs\n\
.segrel\n\
jmp	@L%d(bx)\n\
L%d:\
"};

/*
 * If the unsigned casts below won't compile,
 * try using the calls to lrem and ldiv.
 */

pswitch(afp, alp, deflab)
struct swtab *afp, *alp;
{
	int ncase, i, j, tabs, worst, best, range;
	register struct swtab *swp, *fp, *lp;
	int *poctab;

	fp = afp;
	lp = alp;
	if (fp==lp) {
		printf("jmp	L%d\n", deflab);
		return;
	}
	isn++;
	if (sort(fp, lp))
		return;
	ncase = lp-fp;
	lp--;
	range = lp->swval - fp->swval;
	/* direct switch */
	if (range>0 && range <= 3*ncase) {
		if (fp->swval)
			printf("sub	ax,#/%x\n", fp->swval);
		printf(dirsw, (range >= -128 && range <= 127? '*':'#'),
			range, deflab, isn, isn);
		isn++;
		for (i=fp->swval; ; i++) {
			if (i==fp->swval) {
				printf("L%d\n", fp->swlab);
				if (fp==lp)
					break;
				fp++;
			} else
				printf("L%d\n", deflab);
		}
		return;
	}
	/* simple switch */
	if (ncase<10) {
		for (fp = afp; fp<=lp; fp++)
			breq(fp->swval, fp->swlab);
		printf("br	L%d\n", deflab);
		return;
	}
	/* hash switch */
	best = 077777;
	poctab = getblk(((ncase+2)/2) * sizeof(*poctab));
	for (i=ncase/4; i<=ncase/2; i++) {
		for (j=0; j<i; j++)
			poctab[j] = 0;
		for (swp=fp; swp<=lp; swp++)
			/* lrem(0, swp->swval, i) */
			poctab[(unsigned)swp->swval%i]++;
		worst = 0;
		for (j=0; j<i; j++)
			if (poctab[j]>worst)
				worst = poctab[j];
		if (i*worst < best) {
			tabs = i;
			best = i*worst;
		}
	}
	i = isn++;
	printf(hashsw, tabs, i, i);
	isn++;
	for (i=0; i<tabs; i++)
		printf("L%d\n", isn+i);
	for (i=0; i<tabs; i++) {
		printf("L%d:", isn++);
		for (swp=fp; swp<=lp; swp++) {
			/* lrem(0, swp->swval, tabs) */
			if ((unsigned)swp->swval%tabs == i) {
				/* ldiv(0, swp->swval, tabs) */
				breq((unsigned)swp->swval/tabs, swp->swlab);
			}
		}
		printf("br	L%d\n", deflab);
	}
}

breq(v, l)
{
	if (v==0)
		printf("test	ax,ax\n");
	else
		printf("cmp	ax,%c%d.\n", (v >= -128 && v <= 127? '*':'#'), v);
	printf("beq	L%d\n", l);
}

sort(afp, alp)
struct swtab *afp, *alp;
{
	register struct swtab *cp, *fp, *lp;
	int intch, t;

	fp = afp;
	lp = alp;
	while (fp < --lp) {
		intch = 0;
		for (cp=fp; cp<lp; cp++) {
			if (cp->swval == cp[1].swval) {
				error("Duplicate case (%d)", cp->swval);
				return(1);
			}
			if (cp->swval > cp[1].swval) {
				intch++;
				t = cp->swval;
				cp->swval = cp[1].swval;
				cp[1].swval = t;
				t = cp->swlab;
				cp->swlab = cp[1].swlab;
				cp[1].swlab = t;
			}
		}
		if (intch==0)
			break;
	}
	return(0);
}

ispow2(atree)
{
	register int d;
	register struct tnode *tree;

	tree = atree;
	if (!isfloat(tree) && tree->tr2->op==CON) {
		d = tree->tr2->value;
		if (d>1 && (d&(d-1))==0)
			return(d);
	}
	return(0);
}

pow2(atree)
struct tnode *atree;
{
	register int d, i;
	register struct tnode *tree;

	tree = atree;
	if (d = ispow2(tree)) {
		for (i=0; (d=>>1)!=0; i++);
		tree->tr2->value = i;
		switch (tree->op) {

		case TIMES:
			tree->op = LSHIFT;
			break;

		case ASTIMES:
			tree->op = ASLSH;
			break;

		case DIVIDE:
		case UDIV:
			tree->op = ULSH;
			tree->tr2->value = i;
			break;

		case ASDIV:
		case ASUDIV:
			tree->op = ASULSH;
			tree->tr2->value = i;
			break;

		case MOD:
		case UMOD:
			tree->op = AND;
			tree->tr2->value = (1<<i)-1;
			break;

		case ASMOD:
		case ASUMOD:
			tree->op = ASAND;
			tree->tr2->value = (1<<i)-1;
			break;

		default:
			error("pow2 botch");
		}
		tree = optim(tree);
	}
	return(tree);
}

cbranch(atree, albl, cond, areg)
struct tnode *atree;
{
	int l1, op;
	register lbl, reg;
	register struct tnode *tree;

	lbl = albl;
	reg = areg;
again:
	if ((tree=atree)==0)
		return;
#ifdef DEBUG
	dbprt("trc","trc - cbranch tree op %d,albl %d, cond %d ,areg %d\n",
	tree->op,albl,cond,areg) ;
#endif
	switch(tree->op) {

	case LOGAND:
		if (cond) {
			cbranch(tree->tr1, l1=isn++, 0, reg);
			cbranch(tree->tr2, lbl, 1, reg);
			label(l1);
		} else {
			cbranch(tree->tr1, lbl, 0, reg);
			cbranch(tree->tr2, lbl, 0, reg);
		}
		return;

	case LOGOR:
		if (cond) {
			cbranch(tree->tr1, lbl, 1, reg);
			cbranch(tree->tr2, lbl, 1, reg);
		} else {
			cbranch(tree->tr1, l1=isn++, 1, reg);
			cbranch(tree->tr2, lbl, 0, reg);
			label(l1);
		}
		return;

	case EXCLA:
		cbranch(tree->tr1, lbl, !cond, reg);
		return;

	case SEQNC:
		rcexpr(tree->tr1, efftab, reg);
		atree = tree->tr2;
		goto again;

	case ITOL:
		tree = tree->tr1;
		break;
	}
	op = tree->op;
	if (opdope[op]&RELAT
	 && tree->tr1->op==ITOL && tree->tr2->op==ITOL) {
		tree->tr1 = tree->tr1->tr1;
		tree->tr2 = tree->tr2->tr1;
		if (op>=LESSEQ && op<=GREAT
		 && (tree->tr1->type==UNSIGN || tree->tr2->type==UNSIGN))
			tree->op = op = op+LESSEQP-LESSEQ;
	}
	if (TESTL(tree)
	  || opdope[op]&RELAT&&TESTL(tree->tr1)){
		longrel(tree, lbl, cond, reg);
		return;
	}
	rcexpr(tree, cctab, reg);
#ifdef DEBUG
	dbprt("trc","cbranch - return from rcexpr\n") ;
#endif
	op = tree->op;
	if ((opdope[op]&RELAT)==0)
		{
		if (isfloat(tree)) {	/* floating point result on stack */
#ifdef INTERMED
#ifdef IEEE
			printf(
			"fstdp\tfac\nfwait\ntest\tfac+6,#0\nsahf\n") ;
#else
			printf("calli\tftest\nsahf\n") ;
#endif
#else
#ifdef IEEE
			printf(
			"fstdp\tfac\nfwait\ntest\tfac+6,#0\nsahf\n") ;
#else
			printf("call\tftest\nsahf\n") ;
#endif
#endif
			fpstack-- ;
			}
		op = NEQUAL;
		}
	else {
		l1 = tree->tr2->op;
	 	if ((l1==CON || l1==SFCON) && tree->tr2->value==0)
			op =+ 200;		/* special for ptr tests */
/*		else
 *			op = maprel[op-EQUAL];
 */	}

	branch(lbl, op, !cond);
}

branch(lbl, aop, c)
{
	register op;

	if(op=aop)
		prins(op, c, branchtab);
	else
		printf("jmp");
	printf("\tL%d\n", lbl);
}

longrel(atree, lbl, cond, reg)
struct tnode *atree;
{
	int xl1, xl2, xo, xz;
	register int op, isrel;
	register struct tnode *tree;

#ifdef DEBUG
	dbprt("trc","trc - longrel tree op %d,lbl %d,cond %d,reg %d\n",
	atree->op,lbl,cond,reg) ;
#endif
	reorder(&atree, cctab, reg);
	tree = atree;
	isrel = 0;
	if (opdope[tree->op]&RELAT) {
		isrel++;
		op = tree->op;
	} else
		op = NEQUAL;
	if (!cond)
		op = notrel[op-EQUAL];
	xl1 = xlab1;
	xl2 = xlab2;
	xo = xop;
	xlab1 = lbl;
	xlab2 = 0;
	xop = op;
	xz = xzero;
	xzero = !isrel || tree->tr2->op==ITOL && tree->tr2->tr1->op==CON
		&& tree->tr2->tr1->value==0;
	if (cexpr(tree, cctab, reg) < 0) {
		reg = rcexpr(tree, regtab, reg);
		printf("test\t%s,%s\njne	L%d\ntest\t%s,%s\n",
		       reg_names[reg], reg_names[reg], 
		       !cond?isn:xlab1,
		       reg_names[reg-1], reg_names[reg-1]);
		xz = isn++;
		branch(xlab1, op, 0);
		printf("L%d:\t", xz);
	}
	xlab1 = xl1;
	xlab2 = xl2;
	xop = xo;
	xzero = xz;
}

/*
 * Tables for finding out how best to do long comparisons.
 * First dimen is whether or not the comparison is with 0.
 * Second is which test: e.g. a>b->
 *	cmp	a,b
 *	bgt	YES		(first)
 *	blt	NO		(second)
 *	cmp	a+2,b+2
 *	bhi	YES		(third)
 *  NO:	...
 * Note some tests may not be needed.
 */
char	lrtab[2][3][6] {
	0,	NEQUAL,	LESS,	LESS,	GREAT,	GREAT,
	NEQUAL,	0,	GREAT,	GREAT,	LESS,	LESS,
	EQUAL,	NEQUAL,	LESSEQP,LESSP,	GREATQP,GREATP,

	0,	NEQUAL,	LESS,	LESS,	GREATEQ,GREAT,
	NEQUAL,	0,	GREAT,	0,	0,	LESS,
	EQUAL,	NEQUAL,	EQUAL,	0,	0,	NEQUAL,
};

xlongrel(f)
{
	register int op, bno;

	op = xop;
	if (f==0) {
		if (bno = lrtab[xzero][0][op-EQUAL])
			branch(xlab1, bno, 0);
		if (bno = lrtab[xzero][1][op-EQUAL]) {
			xlab2 = isn++;
			branch(xlab2, bno, 0);
		}
		if (lrtab[xzero][2][op-EQUAL]==0)
			return(1);
	} else {
		branch(xlab1, lrtab[xzero][2][op-EQUAL], 0);
		if (xlab2)
			label(xlab2);
	}
	return(0);
}

label(l)
{
	printf("L%d:", l);
}

popstk(a)
{
	if (a==0) return;
	printf("add	sp,%c%d.\n",(a<128?'*':'#'),a);
}

error(s, p1, p2, p3, p4, p5, p6)
{

	nerror++;
	fprintf(stderr, "%d: ", line);
	fprintf(stderr, s, p1, p2, p3, p4, p5, p6);
	putc('\n', stderr);
}

/*
 * Read in an intermediate file.
 */
#define	STKS	100
getree()
{
	struct tnode *expstack[STKS];
	register struct tnode **sp;
	register t, op;
	int cond ;
	static char s[9];
	struct swtab *swp;
	double atof();
	char numbuf[64];
	struct tname *np;
	struct xtname *xnp;
	struct ftconst *fp;
	struct lconst *lp;
	struct fasgn *sap;

	curbase = funcbase;
	sp = expstack;
#ifdef DEBUG
	dbprt("trc","getree called\n") ;
#endif
	for (;;) {
		if (sp >= &expstack[STKS])
			error("Stack overflow botch");
		op = geti();
		if ((op&0177400) != 0177000) {
			error("Intermediate file error");
			exit(1);
		}
		lbl = 0;
#ifdef DEBUG
		dbprt("file","file - op is %d,%s\n",op&0377,opntab[op&0377]) ;
#endif
		switch(op =& 0377) {

	case SINIT:
		printf("/%x\n", geti());
		break;

	case EOFC:
		return;

	case BDATA:
		if (geti() == 1) {
			t = 0;
			printf(".byte	");
			for (;;)  {
				printf("/%x", geti());
				t++;
				if (geti() != 1)
					break;
				if (t == 9) {
					t = 0;
					printf("\n.byte	");
				} else
					putchar(',');
			}
			if (t != 0)
				putchar('\n');
		}
		break;

	case PROG:
		printf(".text\n");
		break;

	case DATA:
		printf(".data\n");
		break;

	case BSS:
		printf(".bss\n");
		break;

	case SYMDEF:
		outname(s);
		printf(".globl	%.8s\n", s);
		sfuncr.nloc = 0;
		break;

	case RETRN:
/*
		printf("lea\tsp,*-4.(bp)\npop\tsi\npop\tdi\npop\tbp\nret\n");
 */
		/* Tell the optimizer the type of this procedure, so
		   it can figure out what variables it is allowed to
		   stomp.  */
		printf("|RTYP %d\n", geti());
#ifdef INTERMED
		printf("jmpi\tcret\n");
#else
		printf("jmp\tcret\n");
#endif
		break;

	case CSPACE:
		t = outname(s);
		printf(".comm	%.8s,%u\n", t, geti());
		break;

	case SSPACE:
		printf(".blkb\t%u.\n", (t=geti()));
		totspace += (unsigned)t;
		break;

	case EVEN:
		printf(".even\n");
		break;

	case SAVE:
		printf("push\tbp\nmov\tbp,sp\npush\tdi\npush\tsi\n");
		break;

	case SETSTK:
		t = geti()-4;
		if (t==0)
			break;
		if (t<stkbound)
			printf("sub	sp,%c%d.\n", (t < 128 ? '*':'#'), t);
		else
		{
			printf("mov	ax,%c%d.\n", (t < 128 ? '*':'#'), t);
#ifdef INTERMED
			printf("calli	chkstk\n");
#else
			printf("call	chkstk\n");
#endif
		}
		break;

	case PROFIL:
		t = geti();
#ifdef INTERMED
		printf("mov	ax,#L%d\ncalli	mcount\n", t);
#else
		printf("mov	ax,#L%d\ncall	mcount\n", t);
#endif
		printf(".bss\nL%d:.=.+2\n.text\n", t);
		break;

	case SNAME:
		t = outname(s);
		printf("| %s=L%d\n", t, geti());
		break;

	case ANAME:
		t = outname(s);
		printf("| %s=%d.\n", t, geti());
		break;

	case RNAME:
		t = outname(s);
		printf("| %s=%s\n", t, reg_names[geti()]);
		break;

	case SWIT:
		t = geti();
		line = geti();
		curbase = funcbase;
		while(swp=getblk(sizeof(*swp)), swp->swlab = geti())
			swp->swval = geti();
		pswitch(funcbase, swp, t);
		break;

	case C3BRANCH:		/* for fortran [sic] */
		lbl = geti();
		lbl2 = geti();
		lbl3 = geti();
		goto xpr;

	case CBRANCH:
		lbl = geti();
		cond = geti();

	case EXPR:
	xpr:
		line = geti();
		if (sp != &expstack[1]) {
			error("Expression input botch");
			exit(1);
		}
		nstack = 0;
		sp = --sp;
		if (bopt_debug) dtree(*sp, 0);
		*sp = optim(*sp);
		if (aopt_debug) dtree(*sp, 0);
		if (op==CBRANCH)
			cbranch(*sp, lbl, cond, nreg);
		else if (op==EXPR)
			rcexpr(*sp, efftab, nreg);
		else {
#ifdef DEBUG
			dbprt("C3B","C3B - %d,%d,%d line %d\n",
			lbl,lbl2,lbl3,line) ;
#endif
			if (TESTL(*sp)) {
#ifdef DEBUG
				dbprt("C3B","C3B - long \n");
#endif
				rcexpr(tnode(RFORCE, (*sp)->type, *sp), efftab, nreg);
				printf("test\tdx,dx\nbgt\tL%d\n",lbl3) ;
				printf("blt\tL%d\ntest\tax,ax\n",lbl) ;
				printf("bgt\tL%d\nbr\tL%d\n",lbl3,lbl2);
			} else {
				rcexpr(*sp,cctab,nreg) ;
				if ((opdope[(*sp)->op]&RELAT)==0)
					{
					if (isfloat(*sp)) {	
#ifdef DEBUG
						dbprt("C3B",
						"C3B - floating point \n");
#endif
					/* floating point result on stack */
#ifdef INTERMED
						printf("calli\tftest\nsahf\n") ;
#else
						printf("call\tftest\nsahf\n") ;
#endif
						fpstack-- ;
						}
					}
				printf("bgt	L%d\n", lbl3);
				printf("blt	L%d\nbr	L%d\n", lbl, lbl2);
			}
		}
		curbase = funcbase;
		break;

	case NAME:
		t = geti();
		if (t==EXTERN) {
			np = getblk(sizeof(*xnp));
			np->type = geti();
			outname(np->name);
#ifdef DEBUG
			dbprt("file","getree - extern of type %x\n",np->type);
#endif
		} else {
			np = getblk(sizeof(*np));
			np->type = geti();
			np->nloc = geti();
#ifdef DEBUG
			dbprt("file","getree - name type %x,loc %x,class %x\n",
			np->type,np->nloc,t) ;
#endif
		}
		np->op = NAME;
		np->class = t;
		np->regno = 0;
		np->offset = 0;
		*sp++ = np;
		break;

	case CON:
		t = geti();
		*sp++ = tconst(geti(), t);
		break;

	case LCON:
		geti();	/* ignore type, assume long */
		t = geti();
		op = geti();
		if (t==0 && op>=0 || t == -1 && op<0) {
			*sp++ = tnode(ITOL, LONG, tconst(op, INT));
			break;
		}
		lp = getblk(sizeof(*lp));
		lp->op = LCON;
		lp->type = LONG;
		lp->lvalue = ((long)t<<16) + (unsigned)op;	/* nonportable */
		*sp++ = lp;
		break;

	case FCON:
		t = geti();
		outname(numbuf);
		fp = getblk(sizeof(*fp));
		fp->op = FCON;
		fp->type = t;
		fp->value = isn++;
#ifdef HAVEFP
		if(setjmp(fpenv))
			fp->fvalue = 1.0;
		else
			fp->fvalue = atof(numbuf);
#endif
		*sp++ = fp;
		break;

	case FSEL:
		*sp = tnode(FSEL, geti(), *--sp, NULL);
		t = geti();
		(*sp++)->tr2 = tnode(COMMA, INT, tconst(geti(), INT), tconst(t, INT));
		break;

	case STRASG:
		sap = getblk(sizeof(*sap));
		sap->op = STRASG;
		sap->type = geti();
		sap->mask = geti();
		sap->tr1 = *--sp;
		sap->tr2 = NULL;
		*sp++ = sap;
		break;

	case NULLOP:
		*sp++ = tnode(0, 0, NULL, NULL);
		break;

	case LABEL:
		label(geti());
		break;

	case NLABEL:
		t = outname(s);
		printf("%.8s:", t);
		break;

	case RLABEL:
		t = outname(s);
		printf("%.8s:\n", t);
		break;

	case BRANCH:
		branch(geti(), 0);
		break;

	case SETREG:
		nreg = geti()-1;
		printf("|NREG %d\n", nreg);
		break;

	default:
#if DEBUG
		dbprt("trc","trc - getree for %s(%d)\n",opntab[op],op) ;
#endif
		if (opdope[op]&BINARY) {
			if (sp < &expstack[1]) {
				error("Binary expression botch");
				exit(1);
			}
			t = *--sp;
			*sp++ = tnode(op, geti(), *--sp, t);
		} else
			sp[-1] = tnode(op, geti(), sp[-1]);
		break;
	}
	}
}

geti()
{
	register i;

	i = getchar();
	i += getchar()<<8;
#ifdef DEBUG
	dbprt("file","geti returns %x\n",i) ;
#endif
	return(i);
}

outname(s)
{
	register char *p, c;
	register n;

	p = s;
	n = 0;
	while (c = getchar()) {
		*p++ = c;
		n++;
	}
	do {
		*p++ = 0;
	} while (n++ < 8);
	return(s);
}

strasg(atp)
struct fasgn *atp;
{
	register struct tnode *tp;
	register nwords, i;

	nwords = atp->mask/sizeof(int);
#ifdef DEBUG
	dbprt("trc","trc - strasg #words %d,subop %d\n",nwords,atp->tr1->op);
#endif
	tp = atp->tr1;
	if (tp->op != ASSIGN) {
		if (tp->op==RFORCE) {	/* function return */
			if (sfuncr.nloc==0) {
				sfuncr.nloc = isn++;
				printf(".bss\nL%d:.=.+%d\n.text\n", sfuncr.nloc, nwords*sizeof(int));
			}
			atp->tr1 = tnode(ASSIGN, STRUCT, &sfuncr, tp->tr1);
			strasg(atp);
			printf("mov	ax,#L%d\n", sfuncr.nloc);
			return;
		}
		if (tp->op==CALL) {
			rcexpr(tp, efftab, nreg);
			return;
		}
		error("Illegal structure operation");
		return;
	}
	tp->tr2 = strfunc(tp->tr2);
	if (nwords==1)
		setype(tp, INT);
	else if (nwords==sizeof(int))
		setype(tp, LONG);
	else {
		int regl, regr;
		struct tnode *xp;

		if (tp->tr1->op!=NAME && tp->tr1->op!=STAR
		 || tp->tr2->op!=NAME && tp->tr2->op!=STAR) {
			error("unimplemented structure assignment");
			return;
		}
		tp->tr1 = tnode(AMPER, STRUCT+PTR, tp->tr1);
		tp->tr2 = tnode(AMPER, STRUCT+PTR, tp->tr2);
		tp->op = STRSET;
		tp->type = STRUCT+PTR;
		tp = optim(tp);
		rcexpr(tp, efftab, nreg);
		printf("pop\tbx\npop\tcx\npush\tdi\npush\tsi\nmov\tsi,bx\nmov\tdi,cx\n");
		printf("mov	cx,*%d.\n", nwords);
		printf("repz\nmovs\n");
		printf("pop	si\npop	di\n");
		return;
	}
	rcexpr(tp, efftab, nreg);
}

setype(p, t)
register struct tnode *p;
register t;
{

	for (;; p = p->tr1) {
		p->type = t;
		if (p->op==AMPER)
			t = decref(t);
		else if (p->op==STAR)
			t = incref(t);
		else if (p->op==ASSIGN)
			setype(p->tr2, t);
		else if (p->op!=PLUS)
			break;
	}
}

/*
 * Reduce the degree-of-reference by one.
 * e.g. turn "ptr-to-int" into "int".
 */
decref(at)
{
	register t;

	t = at;
	if ((t & ~TYPE) == 0) {
		error("Illegal indirection");
		return(t);
	}
	return((t>>TYLEN) & ~TYPE | t&TYPE);
}

/*
 * Increase the degree of reference by
 * one; e.g. turn "int" to "ptr-to-int".
 */
incref(t)
{
#ifdef DEBUG
	dbprt("trc","incref %x\n",t) ;
#endif
#ifdef INTERMED
	if((t&XTYPE) == FUNC)
		return(((t&~TYPE)<<TYLEN) | (t&TYPE) | LPTR);
	else
#endif
		return(((t&~TYPE)<<TYLEN) | (t&TYPE) | PTR);
}
