/*
 * Copyright (C) Microsoft Corporation, 1982
 */
#
/*
 * C object code improver-- second part
 */

/*      Modification History
 *
 *      05/18/82        JGL     M001
 *              - sped up isreg(), the single most heavily used routine
 */

#include "c2.h"

rmove()
{
	register struct node *p;
	register int r;
	register  r1, flt;
	char *c;

	for (p=first.forw; p!=0; p = p->forw) {
	flt = 0;
	if(strncmp(p->code,"fwait",5) == 0) {
		if (*p->forw->code == 'f'){
			p->back->forw = p->forw;
			p->forw->back = p->back;
			continue;
		}
	}

	switch (p->op) {

	case MOV:
		if (p->subop == BYTE) {
			clearreg();
			continue;
		}
		dualop(p);
		if (((r=isreg(regs[RT2])) >= 0 && equstr(regs[r], regs[RT1])) ||
			((r=findrand(regs[RT1],flt))>=0&&r==isreg(regs[RT2]))||
			((r=isreg(regs[RT2]))>=0 && r == isreg(regs[RT1]))) {
			p->forw->back = p->back;
			p->back->forw = p->forw;
			redunm++;
			nchange++;
			continue;
		}

		r = isreg(regs[RT1]);
		r1 = isreg(regs[RT2]);
		if (r >= 0 && r1 >= 0)
			p->subop = 0;
		else if (p->subop == BYTE)
			goto dble;
		repladdr(p, 0, flt);
		dest(regs[RT2], flt);
		if (r >= 0)
			if (r1 >= 0)
				savereg(r1+flt, regs[r+flt]);
			else
				savereg(r+flt, regs[RT2]);
		else
			if (r1 >= 0)
				savereg(r1+flt, regs[RT1]);
			else
				setcon(regs[RT1], regs[RT2]);
		continue;

	case LEA:
		/* convert lea	ax,(di) into mov ax,di
		   -Hans, Feb 10, 82 */
		dualop(p);
		if (strcmp("(di)", regs[RT1]) == 0 ||
		    strcmp("(si)", regs[RT1]) == 0 ||
		    strcmp("(bp)", regs[RT1]) == 0 ||
		    strcmp("(bx)", regs[RT1]) == 0 )
		{
			p->op=MOV;
			for (c=p->code;*c++ != ',';);
			c[0]=c[1];
			c[1]=c[2];
			c[2]=0;
		}
		regs[r=isreg(regs[RT2])][0] = 0;
		regs[r+NREG][0] = 0;
		continue;

	case MUL:
	case DIV:
	case UDIV:
		singop(p);
		repladdr(p, 0, flt);
		regs[0][0] = regs[NREG][0] = 0;
		regs[1][0] = regs[NREG+1][0] = 0;
		ccloc[0] = 0;
		continue;

	case PUSH:
		singop(p);
		repladdr(p, 0, flt);
		continue;

	case AND:
	case OR:
	case XOR:
	case ADD:
	case SUB:
	dble:
		dualop(p);
		if (p->op == SUB && (r = isreg(regs[RT1])) >= 0
		    && r == isreg(regs[RT2])) {
			p->op = MOV;
			strcpy(regs[RT1], ",*0.");
			p->code = copy(2, regs[RT2], regs[RT1]);
			p = p->back;
			continue;
		}
		if (p->op == OR && strcmp(regs[RT1], regs[RT2]) == 0) {
			p->op = CMP;
			p->code = copy(2, regs[RT2], ",*0.");
			nchange++;
			n_ors++;
			continue;
		}
		repladdr(p, 0, flt);
		dest(regs[RT2], flt);
		ccloc[0] = 0;
		continue;

	case CWD:
		regs[1][0] = regs[NREG+1][0] = 0;
		continue;

	case CBW:
		regs[0][0] = regs[NREG][0] = 0;
		continue;

	case LOOP:
		regs[5][0] = regs[NREG+5][0] = 0;
		continue;

	case INC:
	case DEC:
	case NEG:
		singop(p);
		dest(regs[RT1], flt);
		ccloc[0] = 0;
		continue;

	case TEST:
		dualop(p);
		if (strcmp(regs[RT1], regs[RT2]) == 0 && isreg(regs[RT1]) > 0) {
			p->op = CMP;
			p->code = copy(2, regs[RT2], ",*0.");
			continue;
		}
		repladdr(p, 1, flt);
		if (equstr(regs[RT1], ccloc)) {
			p->back->forw = p->forw;
			p->forw->back = p->back;
			p = p->back;
			nrtst++;
			nchange++;
		}
		continue;

	case CMP:
		dualop(p);
		repladdr(p, 1, flt);
		ccloc[0] = 0;
		continue;

	case CBR:
		/* i removed the TEST from here 'cause it's not the same as CMP, ttf */
		if ( p->back->op == CMP ) {
			dualop(p->back);
			r = compare(p->subop, findcon(RT2), findcon(RT1));
			if (r==0) {
 				if (p->forw->op==CBR) {
 					p->back->forw = p->forw;
 					p->forw->back = p->back;
 				} else {
 					p->back->back->forw = p->forw;
 					p->forw->back = p->back->back;
 				}
				decref(p->ref);
				p = p->back->back;
				nchange++;
			} else if (r>0) {
				p->op = JBR;
				p->subop = 0;
				p->back->back->forw = p;
				p->back = p->back->back;
				p = p->back;
				nchange++;
			}
		}

	case NOP:
	case SEG:
		continue;

	case JBR:
		redunbr(p);

	default:
		clearreg();
	}
	}
}

jumpsw()
{
	register struct node *p, *p1;
	register t;
	register struct node *tp;
	int nj;

	t = 0;
	nj = 0;
	for (p=first.forw; p!=0; p = p->forw)
		p->refc = ++t;
	for (p=first.forw; p!=0; p = p1) {
		p1 = p->forw;
		if (p->op == CBR && p1->op==JBR && p->ref && p1->ref
		 && abs(p->refc - p->ref->refc) > abs(p1->refc - p1->ref->refc)) {
			if (p->ref==p1->ref)
				continue;
			p->subop = revbr[p->subop];
			tp = p1->ref;
			p1->ref = p->ref;
			p->ref = tp;
			t = p1->labno;
			p1->labno = p->labno;
			p->labno = t;
			nrevbr++;
			nj++;
		}
	}
	return(nj);
}

short_jump()
{
	register struct tnode *p, *p1;
	int changed;

	for (changed = 1; changed;) {
		changed = 0;
		for (p = first.forw; p; p = p->forw) {
			if (p->op == CBR && !toofar(p)) {
				p->op = SBR;
				nsbr++;
				changed++;
			} else if (p->op == JBR && *(p->code) != '@' &&
				   !toofar(p)) {
				p->op = SB;
				nsbr++;
				changed++;
			}
		}
	}
}

toofar(p)
register struct tnode *p;
{
	register struct tnode *p1;
	register i;
	int dir, f1, f2;

	if (p->labno == 0)
		return(10000);
	if (p->refc > p->ref->refc) {
		i = 2;
		dir = 0;
	} else {
		i = 0;
		dir = 1;
	}

	for (p1 = dir?p->forw:p->back;p1!=p->ref;p1=dir?p1->forw:p1->back) {
		switch(p1->op) {
		case LABEL:
		case NOP:
			break;
		case CBW:
		case CWD:
			i += 1;
			break;
		case SBR:
		case SB:
		case LOOP:
			i += 2;
			break;
		case CBR:
			i += 5;
			break;
		case ADD:
		case ADC:
		case SUB:
		case SBB:
		case AND:
		case OR:
		case CMP:
		case XOR:
			dualop(p1);
			if (p1->op == ADD && strcmp(regs[RT2], "sp") == 0) {
				if (regs[RT1][0] == '*')
					i += 3;
				else
					i += 4;
				break;
			}
			f1 = isreg(regs[RT1]);
			f2 = isreg(regs[RT2]);
			if (f1 >= 0 && f2 >= 0)
				i += 2;
			else if (f1 >= 0) {
				if (regs[RT2][0] == '(')
					i += 2;
				else if(regs[RT2][0]=='*' && index(regs[RT2], '('))
					i += 3;
				else
					i += 4;
			} else if (f2 >= 0) {
				if (regs[RT1][0] == '(')
					i += 2;
				else if(regs[RT1][0]=='*' && index(regs[RT1], '('))
					i += 3;
				else
					i += 4;
			} else {
				i += 2;
				if (regs[RT1][0] == '*' && index(regs[RT1], '('))
					i++;
				else 
					i += 2;
				if (regs[RT2][0] == '*' && index(regs[RT2], '('))
					i++;
				else if (regs[RT2][0] != '(')
					i += 2;
			}
			break;
		case MOV:
		case TEST:
			dualop(p1);
			f1 = isreg(regs[RT1]);
			f2 = isreg(regs[RT2]);
			if (f1 >= 0 && f2 >= 0)
				i += 2;
			else if (f1 >= 0) {
				if (regs[RT2][0] == '(')
					i += 2;
				else if(index(regs[RT2],'(')&&regs[RT2][0]=='*')
					i += 3;
				else
					i += 4;
			} else if (f2 >= 0) {
				if (regs[RT1][0] == '(')
					i += 2;
				else if(index(regs[RT1],'(')&&regs[RT1][0]=='*')
					i += 3;
				else
					i += 4;
			} else {
				if (regs[RT1][0] == '(')
					i += 4;
				else if(index(regs[RT1],'(')&&regs[RT1][0]=='*')
					i += 5;
				else
					i += 6;
			}
			break;
		case SAL:
		case SHR:
		case SAR:
			dualop(p1);
single:
			if (isreg(regs[RT1]) >= 0)
				i += 2;
			else if (index(regs[RT1], '(') && regs[RT1][0] == '*')
				i += 3;
			else
				i += 4;
			break;
#ifdef INTERMED
		case JMPI:
		case CALL:
			singop(p1);
			if (index(regs[RT1], '(') == NULL)
				i += 5;
			else
				i += 4;
			break;
#else
		case CALL:
#endif
		case JBR:
			singop(p1);
			if (index(regs[RT1], '(') == NULL)
				i += 3;
			else
				i += 4;
			break;
		case XCHG:
			dualop(p1);
			if ((f1=isreg(regs[RT1]))>=0&&(f2=isreg(regs[RT2]))>=0)
				if (f1 == 0 || f2 == 0)
					i++;
				else
					i += 2;
			else
				i += 4;
			break;
		case LEA:
			dualop(p1);
			if (regs[RT1][0] == '(')
				i += 2;
			else if (regs[RT1][0] == '*')
				i += 3;
			else
				i += 4;
			break;
		case NEG:
		case MUL:
		case DIV:
		case UDIV:
		case NOT:
			singop(p1);
			goto single;
		case INC:
		case DEC:
		case PUSH:
		case POP:
			singop(p1);
			if (isreg(regs[RT1]) >= 0)
				i += 1;
			else if (regs[RT1][0] == '(')
				i += 2;
			else if (index(regs[RT1], '(') && regs[RT1][0] == '*')
				i += 3;
			else
				i += 4;
			break;
		default:
			i += 6;
		}
	}
	if (i >= -128 && i <= 127)
		return(0);
	return(1);
}

abs(x)
{
	return(x<0? -x: x);
}

equop(ap1, p2)
struct node *ap1, *p2;
{
	register char *cp1, *cp2;
	register struct node *p1;

	p1 = ap1;
	if (p1->op!=p2->op || p1->subop!=p2->subop)
		return(0);
	if (p1->op>0 && p1->op<MOV)
		return(0);
	cp1 = p1->code;
	cp2 = p2->code;
	if (cp1==0 && cp2==0)
		return(1);
	if (cp1==0 || cp2==0)
		return(0);
	while (*cp1 == *cp2++)
		if (*cp1++ == 0)
			return(1);
	return(0);
}

decref(p)
register struct node *p;
{
	if (--p->refc <= 0) {
		nrlab++;
		p->back->forw = p->forw;
		p->forw->back = p->back;
	}
}

struct node *
nonlab(p)
struct node *p;
{
	while (p && p->op==LABEL)
		p = p->forw;
	return(p);
}

char *
alloc(n)
register n;
{
	register char *p;

	n++;
	n &= ~01;
	if (lasta+n >= lastr) {
		if (sbrk(2000) == (char *)-1) {
			fprintf(stderr, "C Optimizer: out of space\n");
			exit(1);
		}
		lastr += 2000;
	}
	p = lasta;
	lasta += n;
	return(p);
}

clearreg()
{
	register int i;

	for (i=0; i<2*NREG; i++)
		regs[i][0] = '\0';
	conloc[0] = 0;
	ccloc[0] = 0;
}

savereg(ai, as)
char *as;
{
	register char *p, *s, *sp;

	if (ai == RBP)
		return;
	sp = p = regs[ai];
	s = as;
	while (*p++ = *s) {
		if (s[0]=='(' && isreg(s+1) != RBP) {
			*sp = 0;
			return;
		}
		if (*s++ == ',')
			break;
	}
	*--p = '\0';
	if (*as == '*' && index(as, '(') == 0)
		strcpy(regs[ai+NREG], as);
}

dest(as, flt)
char *as;
{
	register char *s;
	register int i;

	s = as;
	if ((i = isreg(s)) >= 0 && i < NREG) {
		regs[i][0] = 0;
		regs[i+NREG][0] = 0;
	}
	while ((i = findrand(s, flt)) >= 0)
		regs[i][0] = 0;
	for (; *s; s++) {
		if (*s=='(' && isreg(s+1) != RBP) {
			for (i=0; i<NREG+NREG; i++) {
				if (regs[i][0] != '*' || index(regs[i], '('))
					regs[i][0] = 0;
				conloc[0] = 0;
			}
			return;
		}
	}
}

singop(ap)
struct node *ap;
{
	register char *p1, *p2;

	p1 = ap->code;
	p2 = regs[RT1];
	while (*p2++ = *p1++);
	regs[RT2][0] = 0;
}


dualop(ap)
struct node *ap;
{
	register char *p1, *p2;
	register struct node *p;

	p = ap;
	p1 = p->code;
	p2 = regs[RT2];
	while (*p1 && *p1!=',')
		*p2++ = *p1++;
	*p2++ = 0;
	p2 = regs[RT1];
	*p2 = 0;
	if (*p1++ !=',')
		return;
	while (*p2++ = *p1++);
}

findrand(as, flt)
char *as;
{
	register int i;
	for (i = flt; i<NREG+NREG; i++) {
		if (equstr(regs[i], as))
			return(i%NREG);
	}
	return(-1);
}

/*      isreg() rewritten  M001 */

unsigned int regar[8] = {
			 'b'*256+'p',
			 'c'*256+'x',
			 'b'*256+'x',
			 'd'*256+'i',
			 's'*256+'i',
			 'd'*256+'x',
			 'a'*256+'x',
			 0 };

isreg(as)
char *as;
{
	register unsigned rg;
	int i=8;

	{ register char *cp;
	  cp = as;
	  rg = (*cp++)*256;
	  rg += *cp++;
	}

	{ register unsigned *rp;
	  for (rp = regar-1; --i; ) {
		  if (*++rp == rg)
			  break;
	  }
	}
	return (i-1);
}                       /* end M001 */

convreg(as, r)
char *as;
{
	register char *s;

	s = as;
	switch(r) {
	case 0:
		strcpy(s, "ax");
		break;
	case 1:
		strcpy(s, "dx");
		break;
	case 2:
		strcpy(s, "si");
		break;
	case 3:
		strcpy(s, "di");
		break;
	case 4:
		strcpy(s, "bx");
		break;
	case 5:
		strcpy(s, "cx");
		break;
	case 6:
		strcpy(s, "bp");
		break;
	default:
		fprintf(stderr, "CONVREG BOTCH %d\n", r);
	}
}

/* decides whether a register can be used with byte instructions
   or not.  -Hans, Oct 30, 1981
 */
bytereg(r)
int r;
{
	switch (r) {
	case 0:	/* ax */
	case 1: /* dx */
	case 4:	/* bx */
	case 5:	/* cx */
		return(1);
	default:
		return (0);
	}
}
check()
{
	register struct node *p, *lp;

	lp = &first;
	for (p=first.forw; p!=0; p = p->forw) {
		if (p->back != lp)
			abort();
		lp = p;
	}
}

/* if an address is in a register, and the instruction p refers
   to that address, use the register instead.
 */
repladdr(p, f, flt)
struct node *p;
{
	register r;
	int r1;
	register char *p1, *p2;
	static char rt1[50], rt2[50];

	if (f)
		r1 = findrand(regs[RT2], flt);
	else
		r1 = -1;
	r = findrand(regs[RT1], flt);
	if (r1 >= NREG)
		r1 -= NREG;
	if (r >= NREG)
		r -= NREG;
	if (r>=0 || r1>=0) {
	/* we are only allowed to do this when we are using
	   a byte operand and we are using ax, bx, cx or dx.
	   -Hans, Oct 30, 1981
	 */
	 	if (p->subop == BYTE)
		  if ((r>=0 && !bytereg(r)) ||
		      (r1>=0 && !bytereg (r1))) return;
		p2 = regs[RT1];
		for (p1 = rt1; *p1++ = *p2++;);
		if (regs[RT2][0]) {
			p1 = rt2;
			for (p2 = regs[RT2]; *p1++ = *p2++;);
		} else
			rt2[0] = 0;
		if (r>=0) {
			convreg(rt1, r);
			nsaddr++;
		}
		if (r1>=0) {
			convreg(rt2, r1);
			nsaddr++;
		}
		if (*rt2) {
			strcat(rt2, ",");
			p->code = copy(2, rt2, rt1);
		} else
			p->code = copy(1, rt1);
	}
}

movedat()
{
	register struct node *p1, *p2;
	struct node *p3;
	register seg;
	struct node data;
	struct node *datp;

	if (first.forw == 0)
		return;
	if (lastseg != TEXT && lastseg != -1) {
		p1 = (struct node *)alloc(sizeof(first));
		p1->op = lastseg;
		p1->subop = 0;
		p1->code = NULL;
		p1->forw = first.forw;
		p1->back = &first;
		first.forw->back = p1;
		first.forw = p1;
	}
	datp = &data;
	for (p1 = first.forw; p1!=0; p1 = p1->forw) {
		if (p1->op == DATA) {
			p2 = p1->forw;
			while (p2 && p2->op!=TEXT)
				p2 = p2->forw;
			if (p2==0)
				break;
			p3 = p1->back;
			p1->back->forw = p2->forw;
			p2->forw->back = p3;
			p2->forw = 0;
			datp->forw = p1;
			p1->back = datp;
			p1 = p3;
			datp = p2;
		}
	}
	if (data.forw) {
		datp->forw = first.forw;
		first.forw->back = datp;
		data.forw->back = &first;
		first.forw = data.forw;
	}
	seg = lastseg;
	for (p1 = first.forw; p1!=0; p1 = p1->forw) {
		if (p1->op==TEXT||p1->op==DATA||p1->op==BSS) {
			if (p2 = p1->forw) {
				if (p2->op==TEXT||p2->op==DATA||p2->op==BSS)
					p1->op  = p2->op;
			}
			if (p1->op == seg || p1->forw&&p1->forw->op==seg) {
				if (p1->op == DATA)
					continue;
				p1->back->forw = p1->forw;
				p1->forw->back = p1->back;
				p1 = p1->back;
				continue;
			}
			seg = p1->op;
		}
	}
}

redunbr(p)
register struct node *p;
{
	register struct node *p1;
	register char *ap1;
	char *ap2;

	if ((p1 = p->ref) == 0)
		return;
	p1 = nonlab(p1);
	if (p1->op==TEST || p1->op == CMP)
		dualop(p1);
	else
		return;
	if (p1->forw->op!=CBR)
		return;
	ap1 = findcon(RT1);
	ap2 = findcon(RT2);
	p1 = p1->forw;
	if (compare(p1->subop, ap2, ap1)>0) {
		nredunj++;
		nchange++;
		decref(p->ref);
		p->ref = p1->ref;
		p->labno = p1->labno;
		p->ref->refc++;
	}
}

char *
findcon(i)
{
	register char *p;
	register r;

	p = regs[i];
	if (*p=='*' && index(p, '(') == 0)
		;
	else if ((r = isreg(p)) >= 0)
		p = regs[r+NREG];
	else if (equstr(p, conloc))
		p = conval;
	return(p);
}

compare(oper, cp1, cp2)
register char *cp1, *cp2;
{
	register unsigned n1, n2;

	if (*cp1 != '*'||index(cp1++,'(') || *cp2 != '*'||index(cp2++,'('))
		return(-1);
	n1 = 0;
	while (*cp2 >= '0' && *cp2 <= '9') {
		n1 *= 10;
		n1 += *cp2++ - '0';
	}
	n2 = n1;
	n1 = 0;
	while (*cp1 >= '0' && *cp1 <= '9') {
		n1 *= 10;
		n1 += *cp1++ - '0';
	}
	if (*cp1 == '.')
		cp1++;
	if (*cp2 == '.')
		cp2++;
	if (*cp1=='+')
		cp1++;
	if (*cp2=='+')
		cp2++;
	do {
		if (*cp1++ != *cp2)
			return(-1);
	} while (*cp2++);
	switch(oper) {

	case JEQ:
		return(n1 == n2);
	case JNE:
		return(n1 != n2);
	case JLE:
		return((int)n1 <= (int)n2);
	case JGE:
		return((int)n1 >= (int)n2);
	case JLT:
		return((int)n1 < (int)n2);
	case JGT:
		return((int)n1 > (int)n2);
	case JLO:
		return(n1 < n2);
	case JHI:
		return(n1 > n2);
	case JLOS:
		return(n1 <= n2);
	case JHIS:
		return(n1 >= n2);
	}
	return(-1);
}

setcon(ar1, ar2)
char *ar1, *ar2;
{
	register char *cl, *cv, *p;

	cl = ar2;
	cv = ar1;
	if (*cv != '*')
		return;
	if (!natural(cl))
		return;
	p = conloc;
	while (*p++ = *cl++);
	p = conval;
	while (*p++ = *cv++);
}

equstr(ap1, ap2)
char *ap1, *ap2;
{
	register char *p1, *p2;

	p1 = ap1;
	p2 = ap2;
	do {
		if (*p1++ != *p2)
			return(0) ;
	} while (*p2++) ;
	return(1) ;
} ;

natural(ap)
char *ap;
{
	register char *p;

	p = ap;
	if (*p!='*')
		return(0);
	if (p=index(p, '('))
		if (isreg(p+1) != RBP)
			return(0);
	return(1);
}
