#include "c2.h"
#define LPAREN '('
#define RPAREN ')'

/*
 * C code improver - register live/dead analysis
 */

livedead()
{
	register struct node *p, *p2;
	register char *cp;
	int i;

	for (p = use_set() ; p != &first; p = p->back) {
/*   printf("LD op = %d, code = %s, set %o, used %o\n", p->op, p->code, p->regset, p->regused);  */
		if ( !red_mov(p) )
			xmove(p);
		if (p->op == PUSH && p->back->op == MOV && p->back->subop == 0) {
			if (p->regused == 0)
				goto push1_nope;
			singop(p);
			if (p->regused & ((017<<(regvar+1))&017))
				goto push1_nope;
			i = isreg(regs[RT1]);
			if (i < 0)
				goto push1_nope;
			p2 = p->back;
			dualop(p2);
			/*
			 * The destination must be the same as the source...
			 */
			if (i != isreg(regs[RT2]))
				goto push1_nope;

			if (isreg(regs[RT1]) < 0 && 
				((index(regs[RT1], '*') || index(regs[RT1], '#')) &&
				index(regs[RT1], LPAREN) == NULL))
					goto push1_nope;
			/*
			 * We found a definition. check forward for further use
			 * before reset.
			 */
			for (p2 = p->forw; p2; p2 = p2->forw) {
				if (p2->op == CALL)
					break;
				if (p2->regused&p->regused)
					goto push1_nope;
				if (p2->regset&p->regused)
					break;
			}
/* printf("forw found %d, %s\n", p2->op, p2->code); */
			/*
			 * It appears that the source of the push is set
			 * further back with no uses inbetween, and the
			 * source is not used further on. Change the previous
			 * instruction (if possible) and delete the push.
			 */
			p->regused = p->back->regused;
			p->code = copy(1, regs[RT1]);
			p->back->back->forw = p;
			p->back = p->back->back;
			redunm++;
			nchange++;
		}
push1_nope:
		continue;
	}
	/*
	 *	Check push/pop pairs to see if needed.
	 */
	for (p=first.forw; p; p = p->forw) {
		if (p->op==POP&&p->regset && (p->regset&((017<<(regvar+1))&017))==0) {
/* printf("Try pop %s\n", p->code); */
			for (p2 = p->back; p2 != &first; p2 = p2->back) {
/* printf("pop check %d, %s\n", p2->op, p2->code); */
				if (p2->op == PUSH)
					break;
				if (p2->op == POP)
					goto push_nope;
				if (p2->regused&p->regset)
					goto push_nope;
				if (p2->regset&p->regset)
					goto push_nope;
				if (p2->op == LABEL)
					goto push_nope;
			}
			if (p2 == &first)
				goto push_nope;
			strcpy(regs[RT1], p->code);
			strcat(regs[RT1], ",");
			strcat(regs[RT1], p2->code);
			p2->code = copy(1, regs[RT1]);
			p2->op = MOV;
			p2->regset = p->regset;
			p->forw->back = p->back;
			p->back->forw = p->forw;
			npop++;
			nchange++;
		}
push_nope:	;
/* printf("Got past pushnope\n"); */
	}
}

dbl_xdex()
{
	register struct node *p,*p2,*p3;
	int src,dest,src_mask,dest_mask;
	int src_set;

	use_set();
	for ( p = first.forw ; p ; p = p->forw ) {
		if ( p->op != ADD )
			continue;
		if (p->regset & ((017<<(regvar+1))&017))
			continue;
		dualop(p);
		if ( (src = isreg(regs[RT1])) < 0 )
			continue;
		if ( (dest = isreg(regs[RT2])) < 0 )
			continue;
		src_mask = 1<<src;
		dest_mask = 1<<dest;
		switch ( dest ) {

		case 2:		/* si */
		case 3:		/* di */
			if ( src == 4 || src == 6 ) /* if other reg is bx or bp, ok */
				break;
			else
				goto next_iter;
		case 4:
			if ( src == 2 || src == 3 ) /* if other reg is si or di, ok */
				break;
			else
				goto next_iter;
		default:
			goto next_iter;
		}
		for ( src_set = 0, p2 = p->forw ; p2 ; p2 = p2->forw ) {
			/* we are not allowed to do this across labels
			   because we may be undoing something that
			   cross jumping was expecting.
			   -Hans, Apr 16, 82 */
			if (p2->op == LABEL) goto next_iter;

			if ( p2->regused & dest_mask ) {
				if ( src_set )
					goto next_iter;
				dualop(p2);
				if ( isreg(regs[RT2]) == dest )
					if ( p2->op == MOV )
						break;
					else
						goto next_iter;
				if ( p2->regset&dest_mask )
					goto next_iter;
				if ( isreg(regs[RT1]) == dest )
					goto next_iter;
			} else if ( p2->regset&dest_mask )
				break;
			src_set = src_set || p2->regset&src_mask;
		}
		if ( p2 )
			p2 = p2->forw;
		for ( p3 = p->forw ; p3 != p2 ; p3 = p3->forw ) {
			dualop(p3);
			if ( mak_dbl(regs[RT1],dest,src) | mak_dbl(regs[RT2],dest,src) ) {
				if ( regs[RT1][0] != 0 )
					strcat(regs[RT2],",");
				p3->code = copy(2,regs[RT2],regs[RT1]);
				p3->regused |= src_mask;
			}
		}
		p->forw->back = p->back;
		p->back->forw = p->forw;
		nchange++;
	next_iter: 
		continue;
	}
}

mak_dbl(reg,dest,src)
char *reg; int dest,src;
{
	register char *cp;

	if ( (cp = index(reg,LPAREN)) && isreg(cp+1) == dest ) {
		cp = index(cp,RPAREN) + 1;
		*cp++ = LPAREN;
		convreg(cp,src);
		*(cp+2) = RPAREN;
		*(cp+3) = 0;
		return 1;
	}
	return 0;
}

use_set()
{
	char *cp;
	register int i;
	register struct node *p, *p3;
	struct node *p2;
	int not_set;

	for (p=first.forw; p; p = p->forw) {
		p2 = p;
		p->regused = p->regset = 0;
		switch(p->op) {
		case ADD:
		case SUB:
		case ADC:
		case SBB:
		case AND:
		case OR:
		case XOR:
			dualop(p);
			if ((i = isreg(regs[RT2])) >= 0) {
				p->regset |= 1<<i;
				p->regused |= 1<<i;
			} else if ((cp = index(regs[RT2], LPAREN)) && (i=isreg(cp+1)) >= 0)
				p->regused |= 1<<i;
			if ((i = isreg(regs[RT1])) >= 0)
				p->regused |= 1<<i;
			else if ((cp = index(regs[RT1], LPAREN)) && (i=isreg(cp+1)) >= 0)
				p->regused |= 1<<i;
			continue;

		case SAL:
		case SAR:
		case SHR:
			dualop(p);
			if ( strcmp(regs[RT1],"cl") == 0 )
				p->regused = 1<<5; /* uses cx for count */
			if ((i = isreg(regs[RT2])) >= 0) {
				p->regset |= 1<<i;
				p->regused |= 1<<i;
			} else if ((cp = index(regs[RT2], LPAREN)) && (i=isreg(cp+1)) >= 0)
				p->regused |= 1<<i;
			continue;

		case MOV:
		case LEA:
			dualop(p);
			if (strcmp(regs[RT2], "sp") == 0)
				p->regset = -1;
			if ((i = isreg(regs[RT2])) >= 0)
				p->regset |= 1<<i;
			else if ((cp = index(regs[RT2], LPAREN)) && (i=isreg(cp+1)) >= 0)
				p->regused |= 1<<i;
			if ((i = isreg(regs[RT1])) >= 0)
				p->regused |= 1<<i;
			else if ((cp = index(regs[RT1], LPAREN)) && (i=isreg(cp+1)) >= 0)
				p->regused |= 1<<i;
			continue;

		case TEST:
		case CMP:
			dualop(p);
			if ((i = isreg(regs[RT1])) >= 0)
				p->regused |= 1<<i;
			else if ((cp = index(regs[RT1], LPAREN)) && (i=isreg(cp+1)) >= 0)
				p->regused |= 1<<i;
			if ((i = isreg(regs[RT2])) >= 0)
				p->regused |= 1<<i;
			else if ((cp = index(regs[RT2], LPAREN)) && (i=isreg(cp+1)) >= 0)
				p->regused |= 1<<i;
			continue;

		case XCHG:
			dualop(p);
			if ((i = isreg(regs[RT2])) >= 0) {
				p->regset |= 1<<i;
				p->regused |= 1<<i;
			} else if ((cp = index(regs[RT2], LPAREN)) && (i=isreg(cp+1)) >= 0)
				p->regused |= 1<<i;
			if ((i = isreg(regs[RT1])) >= 0) {
				p->regset |= 1<<i;
				p->regused |= 1<<i;
			} else if ((cp = index(regs[RT1], LPAREN)) && (i=isreg(cp+1)) >= 0)
				p->regused |= 1<<i;
			continue;

		case CALL:
			p->regset = -1; /* sets all regs */
		case PUSH:
		case CBR:
		case JBR:
		case JMP:
#ifdef INTERMED
		case JMPI:
#endif
			singop(p);

			/* hack to catch returns.  Pretend we are long,
			   just in case.  this supplants |RTYPE function
			   so at least we get a little of its effect.
			   -Hans, Feb 18, 1982
			*/
			if (!strcmp("cret", regs[RT1]))
			{
				p->regused = 3;	/* uses AX and DX */
				p->regset = -1; /* forget about all else */
				continue;
			}

			if ((i = isreg(regs[RT1])) >= 0)
				p->regused |= 1<<i;
			else if ((cp = index(regs[RT1], LPAREN)) && (i=isreg(cp+1)) >= 0)
				p->regused |= 1<<i;
			continue;

		case POP:
			singop(p);
			if ((i = isreg(regs[RT1])) >= 0)
				p->regset |= 1<<i;
			else if ((cp = index(regs[RT1], LPAREN)) && (i=isreg(cp+1)) >= 0)
				p->regused |= 1<<i;
			continue;

		case INC:
		case DEC:
		case NOT:
		case NEG:
			singop(p);
			if ((i = isreg(regs[RT1])) >= 0) {
				p->regset |= 1<<i;
				p->regused |= 1<<i;
			} else if ((cp = index(regs[RT1], LPAREN)) && (i=isreg(cp+1)) >= 0)
				p->regused |= 1<<i;
			continue;

		case MUL:
		case DIV:
		case UDIV:
			singop(p);
			p->regset |= 3; /* AX and DX are set */
			p->regused |= 1;/* AX is used */
			if ((i = isreg(regs[RT1])) >= 0)
				p->regused |= 1<<i;
			 else if ((cp = index(regs[RT1], LPAREN)) && (i=isreg(cp+1)) >= 0)
				p->regused |= 1<<i;
			continue;

		case CBW:
			p->regused |= 1;/* Uses AX */
			p->regset |= 1; /* changes AX */
			continue;

		case CWD:
			p->regused |= 1;/* Uses AX */
			p->regset |= 2; /* changes DX */
			continue;

		case NOP:
		case REGVAR:
		case LABEL:
		case EROU:
		case END:
		case SEG:
			continue;

		case LOOP:
			p->regused = p->regset = 1<<5; /* modifies CX */
			continue;

		case RETYPE:
			if ( atoi(p->code) == LONG )
				p->regused = 3;	/* uses AX and DX */
			else
				p->regused = 1;	/* used just AX */
			p->regset = -1; /* forget about all else */
			continue;

		default:
			p->regused = -1;  /* Who knows? set all regs used and set */
			p->regset = -1;
			continue;
		}
	}
	for (p=first.forw; p; p = p->forw) {
#ifdef INTERMED
		if ( (p->op == JBR || p->op == JMPI) && p->ref ) {
#else
		if ( p->op == JBR && p->ref ) {
#endif
			not_set = -1;
#ifdef INTERMED
			for (p3=p->ref->forw;
			     p3 && p3->op!=JMPI && p3->op!=JBR;
			     p3 = p3->forw ) {
#else
			for (p3=p->ref->forw; p3 && p3->op!=JBR; p3=p3->forw ) {
#endif
				p->regused |= p3->regused&not_set;
				not_set &= ~((~p3->regused)&p3->regset);
				if ( p3->op == RETYPE )
					break;
			}
			p->regset = -1;
		}
	}
	return p2;
}

mov_to_sub()
{
	struct tnode *t;
	int r;

	for (t=first.forw; t; t=t->forw) {
		if (t->op == MOV) {
			dualop(t);
			if (isreg(regs[RT2]) >= 0 &&
			    strcmp(regs[RT1],"*0.") == 0) {
				t->op = SUB;
				strcpy(regs[RT1], regs[RT2]);
				strcat(regs[RT2], ",");
				t->code = copy(2, regs[RT2], regs[RT1]);
			}
		}
		if (t->op == CMP) {
			dualop(t);
			if (isreg(regs[RT2]) >= 0 &&
			    strcmp(regs[RT1],"*0.") == 0) {
				t->op = TEST;
				strcpy(regs[RT1], regs[RT2]);
				strcat(regs[RT2], ",");
				t->code = copy(2, regs[RT2], regs[RT1]);
			}
		}
		if (t->op == AND && t->forw->op != CBR) {
			dualop(t);
			if ((r=isreg(regs[RT2])) >= 0 && r <= 1 &&
			    strcmp(regs[RT1], "#255.") == 0) {
				t->subop = BYTE;
				regs[RT2][1] = 'h';
				t->op = SUB;
				strcpy(regs[RT1], regs[RT2]);
				strcat(regs[RT2], ",");
				t->code = copy(2, regs[RT2], regs[RT1]);
			}
		}
	}
}
