/*
 * Copyright (C) Microsoft Corporation, 1982
 */

#include "c2.h"
 /* M0001 -  chk_rep never excluded bp for register interchangs */

red_mov(p)
register struct node *p;
{
	register struct node *p1,*p2;
	char *cp;
	int src,dest,ok;
	int src_mask,dst_mask;

	if ( (p->op != MOV && p->op != XCHG) || p->subop )
		return 0;
	if ( p->regused == 0 )
		return 0;
	dualop(p);
	if ( (dest = isreg(regs[RT2])) < 0 )
		return 0;
	if ( (src = isreg(regs[RT1])) < 0 )
		return 0;
	if ( p->op == XCHG && src != 0 )
		return 0;
	if ( p->regused & ((017<<(regvar+1))&017) )
		return 0;
	src_mask = 1<<src;
	dst_mask = 1<<dest;
	ok = 0;
	for ( p1 = p->back ; p1 != &first ; p1 = p1->back ) {
		if ( chk_rep(p1,src,dest) )
			break;
		if ( (src_mask&p1->regset) && !(src_mask&p1->regused) ) {
			ok = 1;
			break;
		}
		if ( dst_mask & p1->regused )
			break;
		if ( p1->op == LABEL )
			break;
	}
	if ( !ok )
		return 0;
	/*
	 * We found a definition. check forward for further use
	 * before reset.
	 */
	if (p->op != XCHG)
		for (p2 = p->forw; p2; p2 = p2->forw) {
			if (p2->regused&src_mask)
				return 0;
			if (p2->regset&src_mask)
				break;
			if ( p2->op == JBR )
				break;
		}
/* printf("forw found %d, %s\n", p2->op, p2->code); */
	/*
	 * It appears that the source of the move is set
	 * further back with no uses of the destination
	 * inbetween, and the
	 * source is not used further on. Change the previous
	 * instructions (if possible) and delete the move.
	 */
	for ( ; p1 != p ; p1 = p1->forw )
		repl_reg(p1,src,dest);
	p->forw->back = p->back;
	p->back->forw = p->forw;
	redunm++;
	nchange++;
	return 1;
}

chk_rep(p,old,new)
struct node *p; int old,new;
{
	char *cp;

	if (new == 6 || old == 6) /* M0001 */
		return 1; /* can't change value of bp */
	if ( p->subop && (new == 2 || new == 3) )
		return 1; /* can't use si or di for byte stuff */
	if ( (old == 2 || old == 3 || old == 4)
			&& (new == 2 || new == 3 || new == 4) )
		return 0; /* si,di, and bx are interchangeable */
	switch ( p->op ) {

	case DIV:
	case UDIV:
	case MUL:
	case CWD:
	case JBR:
		if ( old == 0 || old == 1 )
			return 1; /* can't change ax and dx useage on these */
		break;
	case CBW:
		if ( old == 0 )
			return 1; /* can't change ax on this */
		break;
	case LOOP:
		if ( old == 5 )
			return 1; /* can't change cx on this */
		break;
	case CALL:
		return 1; /* can't change any regs on call inst */

	case SAL:
	case SAR:
	case SHR:
		dualop(p);
		if ( strcmp(regs[RT1],"cl") == 0 && old == 5 )
			return 1; /* can't change cx on this */
		if ( (cp = index(regs[RT2],'(')) && isreg(cp+1) == old )
			return 1; /* can't index with ax, cx or dx */
		break;

	default:
		dualop(p);
		if ( (cp = index(regs[RT1],'(')) && isreg(cp+1) == old )
			return 1; /* can't index with ax, cx or dx */
		if ( (cp = index(regs[RT2],'(')) && isreg(cp+1) == old )
			return 1; /* can't index with ax, cx or dx */
		break;
	}
	return 0; /* otherwise all are interchangeable */
}

repl_reg(p,old,new)
register struct node *p; int old,new;
{
	register char *cp,*cpp;
	static char *regname[] = {
		"ax","dx","si","di","bx","cx" };

	if ( p->regused&(1<<old) )
		p->regused = (p->regused&(~(1<<old)))|(1<<new);
	if ( p->regset&(1<<old) )
		p->regset = (p->regset&(~(1<<old)))|(1<<new);
	for ( cp = p->code ; *cp ; ) {
		if ( isreg(cp) == old ) {
			for ( cpp = regname[new] ; *cpp ; )
				*cp++ = *cpp++;
		} else {
			while ( *cp && *cp != '(' && *cp != ',' )
				++cp;
			if ( *cp )
				++cp;
		}
	}
}
