#if DEBUG || DEBUGON
#include	<stdio.h>

#define	MAXFLAG 14
#define MAXFILE 132

struct debug
	{
	struct debug *dbnext ;	/* next debug file */
	char	*dbflag ;	/* debugging flag */
	char	*dbfnam ;	/* file name */
	FILE	*dbfile ;	/* debug list file */
	} ;

static struct debug *dblist ;	/* debug list */

dbinit(option)
	char *option ;
	{
	char flag[MAXFLAG],file[MAXFILE] ;
	register char *cp,*buf ;
	struct debug *db,*olddb ;
	int fileflag = 0,found = 0 ;
	buf = flag ;
	for(cp=option;*cp;cp++)
		{			/* break up flag,file */
		if(*cp == ',')
			{
			fileflag = 1 ;	/* file has been specified */
			*buf = 0 ;	/* teminate flag string */
			buf = file ;
			}
		else
			{
			*buf++ = *cp ;	/* add to current name */
			}
		}
	*buf = 0 ;			/* terminate file string */
	db = (struct debug *)calloc(sizeof(struct debug),1) ;
					/* allocate new list entry */
	db->dbflag = (char *)malloc(strlen(flag)+1) ;
	strcpy(db->dbflag,flag) ;	/* copy flag */
	if(!fileflag)
		{
		db->dbfnam = 0 ;
		db->dbfile = stdout ;	/* no file! use standard out */
		}
	else
		{			/* look for previous opening */
		db->dbfnam = (char *)malloc(strlen(file)+1) ;
		strcpy(db->dbfnam,file);/* copy file name */
		for(olddb = dblist;olddb && !found;olddb = olddb->dbnext)
			{		/* search for flag in list */
			if(olddb->dbfnam && !strcmp(file,olddb->dbfnam))
				{	/* file already open */
				db->dbfile = olddb->dbfile ;
				found = 1 ;	/* use same file */
				}
			}
		if(!found)
			db->dbfile = fopen(file,"w") ;
					/* open file for 1st time */
		}
	db->dbnext = dblist ;
	dblist = db ;			/* insert in list */
	} ;

dbprt(flag,fmt,s1,s2,s3,s4,s5,s6,s7,s8)
	char *flag ;
	char *fmt ;
	{
	register struct debug *db ;
	for(db = dblist;db;db = db->dbnext)
		{			/* search for flag in list */
		if(!strcmp(flag,db->dbflag))
			{		/* flag is on - print the request */
			fprintf(db->dbfile,fmt,s1,s2,s3,s4,s5,s6,s7,s8) ;
			return ;
			}
		}
	}

dbdo(flag,proc,s1,s2,s3,s4,s5,s6,s7,s8)
	char *flag ;
	int (*proc)() ;
	{
	register struct debug *db ;
	for(db = dblist;db;db = db->dbnext)
		{			/* search for flag in list */
		if(!strcmp(flag,db->dbflag))
			{		/* flag is on - execute the proc */
			(*proc)(s1,s2,s3,s4,s5,s6,s7,s8) ;
			return ;
			}
		}
	}

dbterm()
	{
	register struct debug *db ;
	for(db = dblist;db;db = db->dbnext)
		{			/* close open files except stdout */
		if(db->dbfile != stdout)
			fclose(db->dbfile) ;
		}
	} ;
#else
/* debug turned off */
#endif
